package org.xbib.multiserv.api;

public interface CommandFunction {

    String getCommandName();

    Object getOuterInstance();

    Class<? extends Command<?>> getCommandClass();

    static CommandFunction of(String commandName, Object outerInstance, Class<? extends Command<?>> commandClass) {
        return new CommandFunction() {
            @Override
            public String getCommandName() {
                return commandName;
            }

            @Override
            public Object getOuterInstance() {
                return outerInstance;
            }

            @Override
            public Class<? extends Command<?>> getCommandClass() {
                return commandClass;
            }
        };
    }
}
