package org.xbib.multiserv.api;

import java.io.IOException;
import java.net.InetAddress;
import java.util.List;
import java.util.Map;

public interface CommandServer {

    void start(InetAddress address, int port) throws IOException;

    Thread shutdownThread();

    InetAddress getAddress();

    List<Integer> getPorts();

    void waitFor() throws InterruptedException;

    void shutdown();

    List<CommandFunction> getFunctions();

    Map<String, Command<?>> getMethods();

    void addPlugin(Plugin plugin);

    Plugin getPlugin(Class<? extends Plugin> pluginClass);
}
